//| BetterVol_CDRW_Alert_TRO_MODIFIED_VERSION                        |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+

// http://www.forexfactory.com/showpost.php?p=2773715&postcount=1623
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_color2 Red
#property indicator_color3 Lime

extern int     MAPeriod = 100;
extern int     LookBack = 20;

extern double  Offset = 5;

int NumberOfBars;
datetime       alertonce = 0;
double R[],D[],S[],W[], Buf[];

bool redVol;
bool whiteVol;

string symbol, tChartPeriod,  tShortName ;  
int    digits, period, digits2  ; 
double point ;

int    barshift ;
double V,O,H,L,C,R1,V1,O1,H1,L1,C1,R2,V2,O2,H2,L2,C2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
  
      Offset = Offset*Point;

      SetIndexBuffer(0,D);
      SetIndexStyle(0,DRAW_NONE,0,0);
      SetIndexArrow(0, 233);
      SetIndexLabel(0,"Demand");
      
      SetIndexBuffer(1,S);
      SetIndexStyle(1,DRAW_NONE,0,0);
      SetIndexArrow(1,234);
      SetIndexLabel(1,"Supply");
      
      SetIndexBuffer(2,W);
      SetIndexStyle(2,DRAW_NONE,0,1);
      SetIndexArrow(2, 251);
      SetIndexLabel(2,"debug");

      SetIndexBuffer(3,Buf);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexLabel(3,"alert");
            
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   //BetVol vars
   double VolLowest,Range,Value2,Value3,HiValue2,HiValue3,LoValue3,tempv2,tempv3,tempv;
   int limit;
   string cdrwsl,cdrwen,cdrwbe,cdrwtp;
   int counted_bars=IndicatorCounted();
   //CDRW Vars
   double spd1,spd2,v1,v2;
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   NumberOfBars = Bars-counted_bars;
   limit=NumberOfBars; //Bars-counted_bars;   
      
   for(int i=limit; i>=0; i--)  
   //for(int i=0; i<limit; i++)   
   {
            
                     //---------- BEGIN Bet Vol Code   ---------------\\
         Value2=0;Value3=0;HiValue2=0;HiValue3=0;LoValue3=99999999;tempv2=0;tempv3=0;tempv=0;
         
         barshift  = iLowest(NULL,0,MODE_VOLUME,20,i+1) ;
         VolLowest = iVolume(symbol,period,barshift); 
         
         H1 = iHigh(symbol,period,i+1);
         L1 = iLow(symbol,period,i+1);
         C1 = iClose(symbol,period,i+1);
         
         Range = (H1-L1);
         
         V1    = iVolume(symbol,period,i+1);
         
         Value2 = V1*Range;
         
         
         if (  Range != 0 )
            Value3 = V1/Range;
         
         redVol = false;  
         whiteVol = false;              
         
         for ( int n=i+1;n<i+MAPeriod;n++ )
         {
               tempv= iVolume(symbol,period,n+1) + tempv; 
         } // for

          for ( n=i+1;n<i+LookBack;n++)
          {
               V      = iVolume(symbol,period,n) ;
               H      = iHigh(symbol,period,n);
               L      = iLow(symbol,period,n);
               Range  = H - L ;
               tempv2 = V * Range; 
               if ( tempv2 >= HiValue2 )
                  HiValue2 = tempv2;
                    
               if ( V * Range != 0 )
               {           
                     tempv3 = V  / Range ;
                     if ( tempv3 > HiValue3 ) 
                        HiValue3 = tempv3; 
                     if ( tempv3 < LoValue3 )
                        LoValue3 = tempv3;
               } // if
          } // for n
                                      
          if ( Value2 == HiValue2  && C1 > Range / 2 )
            {
               //red
               redVol = true;        
            }   

         if ( Value2 == HiValue2  && C1 <= Range / 2 )
            {
               whiteVol = true;                    
            } 
     
     } // for i       
            
         //---------- END Bet Vol Code   ---------------\\    
                     
         //---------- BEGIN CDRW Code   ---------------\\

                     
      for( i=limit; i>=0; i--)   
      {
         O1 = iOpen(symbol,period,i+1);
         H1 = iHigh(symbol,period,i+1);
         L1 = iLow(symbol,period,i+1);
         C1 = iClose(symbol,period,i+1);

         H2 = iHigh(symbol,period,i+2);
         L2 = iLow(symbol,period,i+2);
      
         spd1 = H1 - L1;
         spd2 = H2 - L2;
         
         R[i]=0; D[i]=0; S[i]=0; W[i]=0;
         
         v1=iVolume(symbol,period,i+1);
         v2=iVolume(symbol,period,i+2);
   
         if ( spd1 > spd2 )
         {
               if ( v1 < v2 )
               {
                     if ( H1-C1 < C1-L1 )
                        {
                           R[i+1] = H1 + Offset;
                           S[i+1] = 0;
                        }   
                     if ( H1-C1 > C1-L1 )
                        {
                           R[i+1] = L1 - Offset;
                           D[i+1] = 0;
                        }
               }  // if         
               if ( v1 > v2 )
               {
                     if ( H1-C1 < C1-L1 )
                        {
                           D[i+1] = L1 - Offset;
                           R[i+1] = 0;
                        }            
                     if ( H1-C1 > C1-L1 )
                        {
                           S[i+1] = H1 + Offset;
                           R[i+1] = 0;
                        }   
                } // if    
         } // if
                        
         if ( spd1 < spd2 )
            
               if ( v1 > v2 )
                  W[i+1] = H1 + Offset;            
      } // end for i
        
         //---------- END CDRW Code   ---------------\\
         

 
   
     while(true)
     {
         if (redVol   && D[1] != 0) { Buf[0] = -1; break ; }  // demand       
         if (whiteVol && S[1] != 0) { Buf[0] =  1; break ; }  // supply
           
         Buf[0] = 0; break ;           
     } // while 
    
    
   return(0);
  }
//+------------------------------------------------------------------+
         