//+------------------------------------------------------------------+
//|                                                VSA RSX BARS.mq4 |
//|                                    Copyright  2008, FOREXflash. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| VSA_RSX_BARS_TRO_MODIFIED_VERSION                               |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, FOREXflash Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Lime
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Yellow
#property indicator_color7 Red
#property indicator_color8 Lime

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3


//---- indicator parameters
//extern string a="_Ma of RSX settings_";
extern int      Len = 10;
extern int      SignalMA = 2;
//extern string   MAMethod ="0:SMA 1:EMA 2:SMMA 3:LWMA";
extern int      MA_Method = 0;
//extern string b="_Shift Bars_";
extern double   Shift = 0.0;



//---- bar buffer
double Buffer1[];
double Buffer2[];
double Buffer5[];
double Buffer6[];
double Buffer7[];
double Buffer8[];
//---- rsx buffer
double rsx[];
double SignalBuffer[];
//----

string symbol, tChartPeriod,  tShortName ;  
int    digits, period, digits2  ; 
double point ;
int    barshift, bars ;
double V,O,H,L,C,R1,V1,O1,H1,L1,C1,R2,V2,O2,H2,L2,C2;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

//---- indicators  

SetIndexStyle( 0, DRAW_HISTOGRAM );
SetIndexBuffer( 0, Buffer5 );
SetIndexStyle( 1, DRAW_HISTOGRAM );
SetIndexBuffer( 1, Buffer6 );
SetIndexStyle( 2, DRAW_HISTOGRAM );
SetIndexBuffer( 2, Buffer7 );
SetIndexStyle( 3, DRAW_HISTOGRAM );
SetIndexBuffer( 3, Buffer8 );
SetIndexStyle( 6, DRAW_HISTOGRAM );
SetIndexBuffer( 6, Buffer1 );
SetIndexStyle( 7, DRAW_HISTOGRAM );
SetIndexBuffer( 7, Buffer2 );


SetIndexStyle(4,DRAW_NONE);
SetIndexBuffer(4,rsx);

SetIndexDrawBegin(4,SignalMA);
   SetIndexDrawBegin(5,SignalMA);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(5,SignalBuffer);
//---- 
IndicatorShortName( "VSA RSX BARS" );
//---- 

return( 0 );
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----

//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator RSX function                                    |
//+------------------------------------------------------------------+
int RSX()
{
   double o,h,l,c;
   double f88, f90;
   double f0, v4, v8, vC, v10, v14, v18, v20;
   double f8, f10, f18, f20, f28, f30, f38, f48, v1C;
   double f50, f58, f60, f68, f70, f78, f80, f40;
   
   double limit=Bars-(Len)-1;

   for (int shift=limit;shift>=0;shift--) 
   {
//         h = iHigh(symbol,period,shift);
//         l = iLow(symbol,period,shift);
         c = iClose(symbol,period,shift);
   
      if (f90 == 0.0) {
      
         f90 = 1.0;
         f0 = 0.0;
         if (Len-1 >= 5) f88 = Len-1.0; else f88 = 5.0;
         f8 = 100.0* c ;
         f18 = 3.0 / (Len + 2.0);
         f20 = 1.0 - f18;
         
      } else{
         if (f88 <= f90) f90 = f88 + 1; else f90 = f90 + 1;
         f10 = f8;
         f8 = 100* c ;
         v8 = f8 - f10;
         f28 = f20 * f28 + f18 * v8;
         f30 = f18 * f28 + f20 * f30;
         vC = f28 * 1.5 - f30 * 0.5;
         f38 = f20 * f38 + f18 * vC;
         f40 = f18 * f38 + f20 * f40;
         v10 = f38 * 1.5 - f40 * 0.5;
         f48 = f20 * f48 + f18 * v10;
         f50 = f18 * f48 + f20 * f50;
         v14 = f48 * 1.5 - f50 * 0.5;
         f58 = f20 * f58 + f18 * MathAbs(v8);
         f60 = f18 * f58 + f20 * f60;
         v18 = f58 * 1.5 - f60 * 0.5;
         f68 = f20 * f68 + f18 * v18;

         f70 = f18 * f68 + f20 * f70;
         v1C = f68 * 1.5 - f70 * 0.5;
         f78 = f20 * f78 + f18 * v1C;
         f80 = f18 * f78 + f20 * f80;
         v20 = f78 * 1.5 - f80 * 0.5;

         if ((f88 >= f90) && (f8 != f10)) f0 = 1.0;
         if ((f88 == f90) && (f0 == 0.0)) f90 = 0.0;
      }

      if ((f88 < f90) && (v20 > 0.0000000001)) {

         v4 = (v14 / v20 + 1.0) * 50.0;
         if (v4 > 100.0) v4 = 100.0;
         if (v4 < 0.0) v4 = 0.0;

      } else {
         v4 = 50.0;
      }
      
      rsx[shift]=v4;
   }
     for(shift=0; shift<limit; shift++)
      SignalBuffer[shift]=iMAOnArray(rsx,Bars,SignalMA,0,MA_Method,shift);
      
   return(0);
   
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
//----
RSX();
//----

int i, CountedBars, Limit;
double Indicator1, Indicator2, Indicator3;
CountedBars = IndicatorCounted();
if (Bars <= 15) return( 0 );
if (CountedBars < 1)
{
for (i = 1;(i <= 15);i = i+1) 
{    

    Buffer5[(Bars - i)] = 0.0;
    Buffer7[(Bars - i)] = 0.0;
    Buffer6[(Bars - i)] = 0.0;
    Buffer8[(Bars - i)] = 0.0;
  }
}

//----

if (CountedBars > 0)  Limit = (Bars - CountedBars);
if (CountedBars == 0) Limit = ((Bars - 15) - 1);
for (i = Limit;(i >= 0);i = i-1) 
{  
         O = iOpen(symbol,period,i);
         H = iHigh(symbol,period,i);
         L = iLow(symbol,period,i);
         C = iClose(symbol,period,i);
       

  Buffer5[i] = 0;
  Buffer7[i] = 0;
  Buffer6[i] = 0;
  Buffer8[i] = 0;
  
//----
  
  if ((rsx[i]>SignalBuffer[i]) ) 
  {

  Buffer5[i] =MathMax( O, C )+Shift;
  Buffer6[i] =MathMin( O, C )+Shift;
  Buffer1[i] =L;
  Buffer2[i] =H;
  } 
  {
  if ((rsx[i]<SignalBuffer[i]) ) 
  {

  Buffer7[i] =MathMax( O, C )+Shift;
  Buffer8[i] =MathMin( O, C )+Shift;
  Buffer2[i] =L;
  Buffer1[i] =H;

  }
 }
}
return( 0 );
}
//+------------------------------------------------------------------+